#pragma once

#include <ActorZmq.hh>
#include <MessageZyre.hh>
#include <Node.hh>

#include <PollerZmq.hh>
#include <SocketZyre.hh>

namespace Salsa {
///
/// \class NodeZyre
///
/// \brief salsa node class
/// \author Matej Fedor <matej.fedor.mf@gmail.com>
/// \author Martin Vala <mvala@cern.ch>
/// \author Branislav Beke <bbeke@badhaven.dev>
///
class NodeManagerZyre;
class NodeZyre : public Node, public ActorZmq {
public:
    /// Construct Zyre node with provided name (and packetizer)
    NodeZyre(std::string name = "");
    /// Destruct Zyre node
    virtual ~NodeZyre();

    virtual int init();
    virtual int exec();
    virtual int finish();

    void                                     addSocket(std::shared_ptr<SocketZyre> socket);
    std::vector<std::shared_ptr<SocketZyre>> sockets() const;
    void                                     addSocket(zsock_t * pSocket);

    void handleZmq(zmsg_t * pMsg);

private:
    std::vector<std::shared_ptr<SocketZyre>> mSockets{};              ///< List of zyre sockets
    std::vector<zsock_t *>                   mZmqSockets{};           ///< List of zmq sockets
    NodeManagerZyre *                        mpNodeManager = nullptr; ///< Job manager
};

} // namespace Salsa
